// package programs;

/* 
 * Copyright (C) 2006  Anders Nilsson <anders.nilsson@cs.lth.se>
 *
 * This file is part of OntologyCompiler.
 */

import AST.Start;
import java.io.File;
import java.io.PrintStream;

public class GenCompiler extends Parser {
	public static void main(String args[]) {
		Start ast = parse(args);

		File siarasDir = new File("siaras");
		if (!siarasDir.isDirectory()) {
			siarasDir.mkdir();
		}
		
		String fileName = null;
		try {
			// Generate JastAdd abstract grammar
			fileName = "siaras/Siaras.ast";
			PrintStream pStream = new PrintStream(new File(fileName));
			ast.genAbsGrammar(pStream);

			// Generate Parser.java
			fileName = "siaras/Parser.java";
			pStream = new PrintStream(new File(fileName));
			ast.genParser(pStream);

			// Generate aspects
			fileName = "siaras/GeneratedAspects.jrag";
			pStream = new PrintStream(new File(fileName));
			ast.genAspects(pStream);

		} catch (java.io.FileNotFoundException e) {
			System.out.println("Could not create file: "+fileName);
			e.printStackTrace();
		}
	}
}
